/* audio volume control for x11 (c) firk 2020-2021
   please respect the authorship
   feel free to use this code for anything */
#include <stdio.h>
#include <stdlib.h>
#include <X11/Xlib.h>
#include "mixer.h"
#include "vol-alsa.h"

unsigned char volume, mute;

extern void handle_audio_mute(void) {
  alsa_volume(8, NULL, &mute);
  mute = !mute;
  alsa_volume(4, NULL, &mute);
  x11_redraw();
}

extern void handle_audio_down(void) {
  alsa_volume(2, &volume, NULL);
  if(volume>3) volume -= 3; else volume = 0;
  alsa_volume(1, &volume, NULL);
  x11_redraw();
}

extern void handle_audio_up(void) {
  alsa_volume(2, &volume, NULL);
  if(volume<97) volume += 3; else volume = 100;
  alsa_volume(1, &volume, NULL);
  x11_redraw();
}

extern void handle_audio_set(unsigned v) {
  alsa_volume(2, &volume, NULL);
  volume = (v<100)?v:100;
  alsa_volume(1, &volume, NULL);
  x11_redraw();
}


int main(int argc, char * * argv) {
  int o, x0, y0, w, h, bw;
  o = x0 = y0 = w = h = bw = 0;
  if(argc>=2) o = atoi(argv[1]);
  if(argc>=3) x0 = atoi(argv[2]);
  if(argc>=4) y0 = atoi(argv[3]);
  if(argc>=5) w = atoi(argv[4]);
  if(argc>=6) h = atoi(argv[5]);
  if(argc>=7) bw = atoi(argv[6]);
  x11_init(NULL,o,x0,y0,w,h,bw);
  init_key_hooks();
  volume = 60;
  mute = 1;
  x11_redraw();
  alsa_volume(10, &volume, &mute);
  while(1) x11_event_cycle(1);
  return 0;
}
